program Weather_Notice;
{* -------------------------------------------------------------------------- *}
{* Weather_Notice                                                             *}
{* (c)1993 Neale Davidson                                                     *}
{* -------------------------------------------------------------------------- *}

{$M $4000,0,0}                         {* Necessary for Drop to DOS           *}
uses rmdoor,
	ripcode,
	strings,
	dos,crt,register;  {* Use the RMDOOR.TPU file!            *}

Type
  Daterec = record
    Year       : word;
    Month      : word;
    Day        : word;
    DayofWeek  : word;
  end;
  Weather = record
    Date       : DateRec;
    Picture    : byte;
    Conditions : string[9];
    Low        : integer;
    High       : integer;
  end;
  Game_File = record
    Title : string;
    Days  : array[1..7] of weather;
  end;
Var
	Weekly   : Game_File;
	RipTerm  : Boolean;
	RipMusic : Boolean;

{$I COMMON.INC}      {* Routines common to door games       *}
{$I RIPPIX.INC}      {* RIP and ANSI pictures for weather   *}

procedure Save_Game(FileName:string);
var
  F : File of Game_File;
begin
  Assign(F,FileName);
  Rewrite(F);
  Write(F,Weekly);
  Close(F);
end;

procedure Load_Game(FileName:string);
var
  F : File of Game_File;
begin
  Assign(F,FileName);
  Reset(F);
  Read(F,Weekly);
  Close(F);
end;

procedure ReadyScreen;
{* Ready display screen *}
begin
  if Ripterm then begin
    RmWriteln(Rip_Reset_Windows);
    RmWriteln(Rip_Color(Color_White));
    RmWriteln(Rip_Line_Style(Line_Solid,0,1));
    RmWriteln(Rip_Line(  5,30 ,635, 30));
    RmWriteln(Rip_Line(  5,300,635,300));
    RmWriteln(Rip_Line(635,30 ,635,300));
    RmWriteln(Rip_Line(  5,30 ,  5,300));
    RmWriteln(Rip_Fill_Style(Fill_Solid,Color_Blue));
    RmWriteln(Rip_Fill(40,40,Color_White));
    RmWriteln(Rip_Line( 95,30, 95,300));
    RmWriteln(Rip_Line(185,30,185,300));
    RmWriteln(Rip_Line(275,30,275,300));
    RmWriteln(Rip_Line(365,30,365,300));
    RmWriteln(Rip_Line(455,30,455,300));
    RmWriteln(Rip_Line(545,30,545,300));
    RmWriteln(Rip_Color(Color_BtCyan));
    RmWriteln(Rip_Font_Style(Font_Bold,0,1));
    RmWriteln(Rip_Text_Xy( 20,25,'sun'));
    RmWriteln(Rip_Text_Xy(110,25,'mon'));
    RmWriteln(Rip_Text_Xy(200,25,'tue'));
    RmWriteln(Rip_Text_Xy(290,25,'wed'));
    RmWriteln(Rip_Text_Xy(380,25,'thu'));
    RmWriteln(Rip_Text_Xy(470,25,'fri'));
    RmWriteln(Rip_Text_Xy(560,25,'sat'));
  end
  else if AnsiColor then begin
    RmClrScr;
    RmSetColor(14,1);
    RmGotoXy( 5,4); RmWriteln('Sunday   ');
    RmGotoXy(15,4); RmWriteln('Monday   ');
    RmGotoXy(25,4); RmWriteln('Tuesday  ');
    RmGotoXy(35,4); RmWriteln('Wednesday');
    RmGotoXy(45,4); RmWriteln('Thursday ');
    RmGotoXy(55,4); RmWriteln('Friday   ');
    RmGotoXy(65,4); RmWriteln('Saturday ');
  end;
end;

procedure DisplayWeather;
var
  I   : integer;
  Tmp : string;
begin
  if Exists('FORCAST.DAT') then begin
    Load_Game('FORCAST.DAT');
    ReadyScreen;
    if RipTerm then begin
      RmWriteln(Rip_Color(15));
      RmWriteln(Rip_Font_Style(Font_Triplex,0,1));
      RmWriteln(Rip_Text_Xy(0,0,Weekly.Title));
    end
    else begin
      RmSetColor(15,0);
      RmGotoXy(40-(length(Weekly.Title) div 2),2);
      RmWriteln(Weekly.Title);
    end;
    for I:=1 to 7 do begin
      Tmp := ToStr(Weekly.Days[I].Date.Day);
      case Weekly.Days[I].Date.Month of
        1  : Tmp := Tmp + ' Jan';   2  : Tmp := Tmp + ' Feb';
        3  : Tmp := Tmp + ' Mar';   4  : Tmp := Tmp + ' Apr';
        5  : Tmp := Tmp + ' May';   6  : Tmp := Tmp + ' Jun';
        7  : Tmp := Tmp + ' Jul';   8  : Tmp := Tmp + ' Aug';
        9  : Tmp := Tmp + ' Sep';   10 : Tmp := Tmp + ' Oct';
        11 : Tmp := Tmp + ' Nov';   12 : Tmp := Tmp + ' Dec';
        else Tmp := Tmp + ' Err';
      end;
      if RipTerm then begin
        RmWriteln(Rip_Color(Color_BtCyan));
        RmWriteln(Rip_Font_Style(Font_Triplex,0,1));
        RmWriteln(Rip_Text_Xy(-70+(90*I),60,Tmp));
      end
      else if AnsiColor then begin
        while Length(Tmp)<9 do Tmp := Tmp + ' ';
        RmSetColor(14,1); RmGotoXy(-5+(10*I),5); RmWriteln(Tmp);
      end;
      case Weekly.Days[I].Picture of
        1 : Draw_Sun(I); {* Sunny *}
        2 : begin        {* Cloudy *}
          Draw_Sun(I);
          Draw_Cloud(I);
        end;
        3 : begin        {* Showers *}
          Draw_Cloud(I);
          Draw_Rain(I);
        end;
        4 : begin        {* Rain *}
          Draw_Cloud(I);
          Draw_Heavy_Rain(I);
        end;
        5 : begin        {* Storms *}
          Draw_Dark_Cloud(I);
          Draw_Heavy_Rain(I);
        end;
        6 : begin        {* Thunder-Storms *}
          Draw_Dark_Cloud(I);
          Draw_Heavy_Rain(I);
          Draw_Lightning(I);
        end;
        7 : begin        {* Snow *}
          Draw_Cloud(I);
          Draw_Snow(I);
        end;
        8 : begin        {* Heavy Snow *}
          Draw_Dark_Cloud(I);
          Draw_Heavy_Snow(I);
        end;
        9 : begin        {* Sleet *}
          Draw_Dark_Cloud(I);
          Draw_Sleet(I);
        end;
        10 : Draw_Wind(I);      {* Wind *}
        11 : Draw_Tree(I);      {* Draw XMas Tree *}
        12 : Draw_Pumpkin(I);   {* Draw Pumpkin *}
        13 : Draw_Valentine(I); {* Draw Heart *}
        14 : Draw_Flag(I);      {* Draw US Flag *}
        else begin
          {* Not Available *}
          RmSetColor(15,1); RmGotoXy(-5+(10*I),6 ); RmWriteln('         ');
          RmSetColor(15,1); RmGotoXy(-5+(10*I),7 ); RmWriteln('No       ');
          RmSetColor(15,1); RmGotoXy(-5+(10*I),8 ); RmWriteln('Available');
          RmSetColor(15,1); RmGotoXy(-5+(10*I),9 ); RmWriteln('Picture  ');
          RmSetColor(15,1); RmGotoXy(-5+(10*I),10); RmWriteln('         ');
        end;
      end;
      if RipTerm then begin
        RmWriteln(Rip_Font_Style(0,0,1));
        RmWriteln(Rip_Color(Color_BtCyan));
        RmWriteln(Rip_Text_Xy(-70+(90*I),200,Weekly.Days[I].Conditions));
        RmWriteln(Rip_Font_Style(Font_Triplex,0,1));
        RmWriteln(Rip_Text_Xy(
          -70+(90*I),220,'LO:'+ToStr(Weekly.Days[I].Low)+#248));
        RmWriteln(Rip_Text_Xy(
          -70+(90*I),240,'HI:'+ToStr(Weekly.Days[I].High)+#248));
      end
      else begin
        Tmp := Weekly.Days[I].Conditions;
        while length(Tmp)<9 do Tmp := Tmp+' ';
        RmSetColor(14,1); RmGotoXy(-5+(10*I),11); RmWriteln(Tmp);
        Tmp := 'LO:'+ToStr(Weekly.Days[I].Low)+#248;
        while length(Tmp)<9 do Tmp := Tmp+' ';
        RmSetColor(14,1); RmGotoXy(-5+(10*I),12); RmWriteln(Tmp);
        Tmp := 'HI:'+ToStr(Weekly.Days[I].High)+#248;
        while length(Tmp)<9 do Tmp := Tmp+' ';
        RmSetColor(14,1); RmGotoXy(-5+(10*I),13); RmWriteln(Tmp);
      end;
    end;
  end
  else begin
    RmWriteln('The Weekly Forcast is not currently available.');
    RmWriteln('We Apologize for the inconvience.');
  end;
end;

procedure Enter_New_Data;
var
  I    : integer;
  Temp : Game_File;
  CH   : Char;
  Tmp  : string;
  Done : Boolean;
begin
	if Not Exists('FORCAST.DAT') then begin
		{* Load Junk Data *}
		Weekly.Title := 'Unknown';
		for I:=1 to 7 do begin
			Weekly.Days[I].Date.Day := I;
			Weekly.Days[I].Date.Month := 1;
			Weekly.Days[I].Picture := I;
			Weekly.Days[I].Conditions := 'Temp';
			Weekly.Days[I].High := 99;
			Weekly.Days[I].Low := -99;
		end;
	end;
	if RipTerm then RmWriteln(Rip_Reset_Windows);
	RmClrScr;
	RmGotoXy(1,1);
	RmSetColor(9 ,0 );
	RmWritelnXy(1,3,'Title:');         RmWritelnXy(1,4,'DayOfWeek:');
	RmWritelnXy(15,4,'Day:');          RmWritelnXy(20,4,'Month:');
	RmWritelnXy(30,4,'Picture:');      RmWritelnXy(40,4,'Conditions:');
	RmWritelnXy(55,4,'High:');         RmWritelnXy(65,4,'Lo:');
	RmWritelnXy(1,5,'Sunday');         RmWritelnXy(1,6,'Monday');
	RmWritelnXy(1,7,'Tuesday');        RmWritelnXy(1,8,'Wednesday');
	RmWritelnXy(1,9,'Thursday');      RmWritelnXy(1,10,'Friday');
	RmWritelnXy(1,11,'Saturday');      RmWritelnXy(1,13,'Picture Key');
	RmWritelnXy(1,14,' [1] Sunny       [2] Cloudy     [3] Showers     [4] Rain');
	RmWritelnXy(1,15,' [5] Storms      [6] T-Storms   [7] Snow        [8] Heavy Snow');
	RmWritelnXy(1,16,' [9] Sleet       [10] Windy     [11] Christmas  [12] Holloween');
	RmWritelnXy(1,17,' [13] Valentine  [14] July 4th');
	Temp := Weekly;
    {* Display Weather Data *}
	RmSetColor(7,0);
	RmWritelnXy(10,3,Weekly.Title);
	for I:=1 to 7 do begin
		RmWritelnXy(15,4+I,ToStr(Weekly.Days[I].Date.Day));
		RmWritelnXy(20,4+I,ToStr(Weekly.Days[I].Date.Month));
		RmWritelnXy(30,4+I,ToStr(Weekly.Days[I].Picture));
		RmWritelnXy(40,4+I,Weekly.Days[I].Conditions);
		RmWritelnXy(55,4+I,ToStr(Weekly.Days[I].High));
		RmWritelnXy(65,4+I,ToStr(Weekly.Days[I].Low));
	end;
	{* Enter new week's information *}
	Done := False;
	Repeat
		RmSetColor(14,0);
		RmWritelnXy(1,18,'Press [T]itle, [1]-[7] to edit a day, or [Q]uit.');
		Ch := GetCh('T1234567Q');
		RmWritelnXy(1,18,'Enter your Data Now                             ');
		RmSetColor(15,0);
		case Ch of
			'T' : begin
				{* Enter Title *}
				RmGotoXy(10,3 );
				Tmp := RmReadSSize(35);
				if Tmp<>'' then Temp.Title := Tmp;
			end;
			'1'..'7' : begin
				{* Edit A Date *}
				I := Ord(Ch)-48;
				repeat
					RmGotoXy(15,4+I);
					Tmp := RmReadSSize(2);
					if Tmp<>'' then Temp.Days[I].Date.Day := Value(Tmp);
				until (Temp.Days[I].Date.Day>0) and (Temp.Days[I].Date.Day<32);
				repeat
					RmGotoXy(20,4+I);
					Tmp := RmReadSSize(2);
					if Tmp<>'' then Temp.Days[I].Date.Month := Value(Tmp);
				until (Temp.Days[I].Date.Month>0) and (Temp.Days[I].Date.Month<13);
				RmGotoXy(30,4+I);
				Tmp := RmReadSSize(2);
				if Tmp<>'' then Temp.Days[I].Picture := Value(Tmp);
				RmGotoXy(40,4+I); Tmp := RmReadSSize(9);
				if Tmp<>'' then Temp.Days[I].Conditions := Tmp;
				RmGotoXy(55,4+I); Tmp := RmReadSSize(3);
				if Tmp<>'' then Temp.Days[I].High := Value(Tmp);
				RmGotoXy(65,4+I); Tmp := RmReadSSize(3);
				if Tmp<>'' then Temp.Days[I].Low := Value(Tmp);
			end;
			'Q' : Done := True;
		end;
	Until Done;
	RmWritelnXy(1,18,'Save this forcast? [Y/N]                        ');
	Ch := GetCh('YN');
	if CH='Y' then begin
		{* Save the new weather information *}
		Weekly := Temp;
		Save_Game('FORCAST.DAT');
	end;
end;

var
	Option : Char;
	I : integer;
	Done : boolean;
begin
	RegisterRmDoor('CIOE Corp','36-2122332');
	DoorName := 'Weather Notice';
	RmWriteln('!|*');
	RmWriteln('Weather Notice');
	RmWriteln('Version 1.50b / 14 May 1994');
	RmWriteln('(c)1994 CIOE Corp');
	RmWriteln('Determining Terminal Capabilities');
	RipTerm := RmDetectRip;
	AnsiColor := RmDetectAnsi;
	REGOK := Check_Registration(BBSName,'Weather Notice');
	if not REGOK then REGOK := Check_Registration(BBSName,'Weather');
	if REGOK then begin
		RmWriteln('This software is registered to '+BBSName);
		RmWriteln('Thank your sysop for registering');
	end
	else begin
		RmWriteln('This program is UNREGISTERED!');
		RmWriteln('We will take a short pause here');
		RmWriteln('to encourage your sysop to register');
		RmWriteln('this program.');
		Delay(10000);
	end;
	Done := False;
	repeat
		DisplayWeather;
		if RipTerm then begin
			NeonLength(250,20);
			RmWriteln(Rip_Font_Style(Font_Small,0,4));
			RIP_Show_Button(300,310,'','Done','D','D');
			if (caps(UserName)=caps(SysopName)) then begin
				Rip_Show_Button(10,310,'','Edit Information','E','E');
			end;
		end
		else begin
			RmSetColor(15,0);
			if (caps(UserName)=caps(SysopName)) then begin
				RmWritelnXy(26,19,'Press [E] to edit Information');
			end;
			RmGotoXy(28,18);
			RmWritelnXy(28,18,'Press [SPACE] to continue');
		end;
		Option := GetCh(' DE');
		if (Option = 'E') and (caps(UserName)=caps(SysopName)) then
			Enter_New_Data
		else Done := True;
		RmClrScr;
	until Done;
	if RipTerm then RmWriteln(Rip_Reset_Windows);
end.